
function fft_gen(p)

fid = fopen('../verilog/FFT.v','w');

% -- wb_[
fprintf(fid,'`ifdef SYNTOOL_OFF \n');
fprintf(fid,'`else \n');
fprintf(fid,'`include "definition.v" \n');
fprintf(fid,'`endif \n\n');

fprintf(fid,'module FFT(CLK, RESET, EN, X_r, X_i, Y_r, Y_i);\n');
fprintf(fid,'input          CLK;\n');
fprintf(fid,'input          RESET;\n');
fprintf(fid,'input          EN;\n');
fprintf(fid,'parameter      IDLE = 0;\n');
fprintf(fid,'parameter      RUN  = 1;\n');
fprintf(fid,'input  [`W-1:0]  X_r, X_i;\n');
fprintf(fid,'output [`W-1:0]  Y_r, Y_i;\n');
fprintf(fid,'reg              state;\n');

for s=1:log2(p.N)
    fprintf(fid,'reg    [`N_AD_BUS-1:0]   k_count_st%d;\n',s);
end
for s=1:log2(p.N)
    fprintf(fid,'wire   [`W-1:0]  Y_st%d_r, Y_st%d_i;\n',s,s);
end

for s=1:log2(p.N)
 if(s==1)
     fprintf(fid,'BUTTERFLY_STAGE1 BUTTERFLY_STAGE1(CLK, k_count_st1,      X_r,     X_i, Y_st1_r, Y_st1_i);\n');
 elseif (s==log2(p.N))
     fprintf(fid,'BUTTERFLY_STAGE%d BUTTERFLY_STAGE%d(CLK, k_count_st%d,  Y_st%d_r, Y_st%d_i, Y_r,     Y_i);\n',s,s,s,s-1,s-1);
 else
     fprintf(fid,'BUTTERFLY_STAGE%d BUTTERFLY_STAGE%d(CLK, k_count_st%d,  Y_st%d_r, Y_st%d_i, Y_st%d_r, Y_st%d_i);\n',s,s,s,s-1,s-1,s,s);
 end
end
 
fprintf(fid,'always@(posedge CLK or negedge RESET)\n');
fprintf(fid,'begin\n');
fprintf(fid,' if(!RESET)\n');
fprintf(fid,'    begin\n');
fprintf(fid,'     state   <= IDLE;\n');
fprintf(fid,'    end\n');
fprintf(fid,' else\n');
fprintf(fid,'   begin\n');

for s=1:log2(p.N)
    if (s==1)
    else
       fprintf(fid,'     k_count_st%d <= k_count_st%d;\n',s,s-1); 
    end
end
fprintf(fid,'     case(state)\n');
fprintf(fid,'        IDLE :\n');
fprintf(fid,'           begin\n');
fprintf(fid,'             k_count_st1 <= 0;\n');
fprintf(fid,'             if(EN == 1) state <= RUN;\n');
fprintf(fid,'             else           state <= IDLE;\n');
fprintf(fid,'           end\n');
fprintf(fid,'        RUN :\n');
fprintf(fid,'           begin\n');
fprintf(fid,'             k_count_st1 <= k_count_st1 + 1;\n');
fprintf(fid,'             if(EN == 0)  state <= IDLE;\n');
fprintf(fid,'           end\n');
fprintf(fid,'      endcase\n');
fprintf(fid,'   end\n');
fprintf(fid,'end\n');
fprintf(fid,'endmodule\n');
fclose(fid);