`ifdef SYNTOOL_OFF 
`else 
`include "definition.v" 
`endif 


module TWIDDLE_ST5(k, W_ex_r, W_r, W_ex_i, W_i);
input          k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input          k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 0;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input          k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 32931;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input          k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input          k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 2;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST4(k, W_ex_r, W_r, W_ex_i, W_i);
input  [1:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [1:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 23170;
 2 : Twiddle_W_r = 0;
 3 : Twiddle_W_r = 42365;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [1:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 42365;
 2 : Twiddle_W_i = 32931;
 3 : Twiddle_W_i = 42365;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [1:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [1:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 2;
 3 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST3(k, W_ex_r, W_r, W_ex_i, W_i);
input  [2:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [2:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 30273;
 2 : Twiddle_W_r = 23170;
 3 : Twiddle_W_r = 12539;
 4 : Twiddle_W_r = 0;
 5 : Twiddle_W_r = 52996;
 6 : Twiddle_W_r = 42365;
 7 : Twiddle_W_r = 35262;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [2:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 52996;
 2 : Twiddle_W_i = 42365;
 3 : Twiddle_W_i = 35262;
 4 : Twiddle_W_i = 32931;
 5 : Twiddle_W_i = 35262;
 6 : Twiddle_W_i = 42365;
 7 : Twiddle_W_i = 52996;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [2:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
 4 : Twiddle_W_ex_r = 0;
 5 : Twiddle_W_ex_r = 0;
 6 : Twiddle_W_ex_r = 0;
 7 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [2:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 0;
 3 : Twiddle_W_ex_i = 0;
 4 : Twiddle_W_ex_i = 2;
 5 : Twiddle_W_ex_i = 0;
 6 : Twiddle_W_ex_i = 0;
 7 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST2(k, W_ex_r, W_r, W_ex_i, W_i);
input  [3:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [3:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 32138;
 2 : Twiddle_W_r = 30273;
 3 : Twiddle_W_r = 27245;
 4 : Twiddle_W_r = 23170;
 5 : Twiddle_W_r = 18204;
 6 : Twiddle_W_r = 12539;
 7 : Twiddle_W_r = 6392;
 8 : Twiddle_W_r = 0;
 9 : Twiddle_W_r = 59143;
 10 : Twiddle_W_r = 52996;
 11 : Twiddle_W_r = 47331;
 12 : Twiddle_W_r = 42365;
 13 : Twiddle_W_r = 38290;
 14 : Twiddle_W_r = 35262;
 15 : Twiddle_W_r = 33397;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [3:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 59143;
 2 : Twiddle_W_i = 52996;
 3 : Twiddle_W_i = 47331;
 4 : Twiddle_W_i = 42365;
 5 : Twiddle_W_i = 38290;
 6 : Twiddle_W_i = 35262;
 7 : Twiddle_W_i = 33397;
 8 : Twiddle_W_i = 32931;
 9 : Twiddle_W_i = 33397;
 10 : Twiddle_W_i = 35262;
 11 : Twiddle_W_i = 38290;
 12 : Twiddle_W_i = 42365;
 13 : Twiddle_W_i = 47331;
 14 : Twiddle_W_i = 52996;
 15 : Twiddle_W_i = 59143;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [3:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
 4 : Twiddle_W_ex_r = 0;
 5 : Twiddle_W_ex_r = 0;
 6 : Twiddle_W_ex_r = 0;
 7 : Twiddle_W_ex_r = 0;
 8 : Twiddle_W_ex_r = 0;
 9 : Twiddle_W_ex_r = 0;
 10 : Twiddle_W_ex_r = 0;
 11 : Twiddle_W_ex_r = 0;
 12 : Twiddle_W_ex_r = 0;
 13 : Twiddle_W_ex_r = 0;
 14 : Twiddle_W_ex_r = 0;
 15 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [3:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 0;
 3 : Twiddle_W_ex_i = 0;
 4 : Twiddle_W_ex_i = 0;
 5 : Twiddle_W_ex_i = 0;
 6 : Twiddle_W_ex_i = 0;
 7 : Twiddle_W_ex_i = 0;
 8 : Twiddle_W_ex_i = 2;
 9 : Twiddle_W_ex_i = 0;
 10 : Twiddle_W_ex_i = 0;
 11 : Twiddle_W_ex_i = 0;
 12 : Twiddle_W_ex_i = 0;
 13 : Twiddle_W_ex_i = 0;
 14 : Twiddle_W_ex_i = 0;
 15 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule


module TWIDDLE_ST1(k, W_ex_r, W_r, W_ex_i, W_i);
input  [4:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
assign W_r = Twiddle_W_r(k);
assign W_i = Twiddle_W_i(k);
assign W_ex_r = Twiddle_W_ex_r(k);
assign W_ex_i = Twiddle_W_ex_i(k);
function [`W-1:0] Twiddle_W_r;
input  [4:0]  k;
case(k)
 0 : Twiddle_W_r = 32604;
 1 : Twiddle_W_r = 32610;
 2 : Twiddle_W_r = 32138;
 3 : Twiddle_W_r = 31357;
 4 : Twiddle_W_r = 30273;
 5 : Twiddle_W_r = 28898;
 6 : Twiddle_W_r = 27245;
 7 : Twiddle_W_r = 25330;
 8 : Twiddle_W_r = 23170;
 9 : Twiddle_W_r = 20787;
 10 : Twiddle_W_r = 18204;
 11 : Twiddle_W_r = 15446;
 12 : Twiddle_W_r = 12539;
 13 : Twiddle_W_r = 9512;
 14 : Twiddle_W_r = 6392;
 15 : Twiddle_W_r = 3211;
 16 : Twiddle_W_r = 0;
 17 : Twiddle_W_r = 62324;
 18 : Twiddle_W_r = 59143;
 19 : Twiddle_W_r = 56023;
 20 : Twiddle_W_r = 52996;
 21 : Twiddle_W_r = 50089;
 22 : Twiddle_W_r = 47331;
 23 : Twiddle_W_r = 44748;
 24 : Twiddle_W_r = 42365;
 25 : Twiddle_W_r = 40205;
 26 : Twiddle_W_r = 38290;
 27 : Twiddle_W_r = 36637;
 28 : Twiddle_W_r = 35262;
 29 : Twiddle_W_r = 34178;
 30 : Twiddle_W_r = 33397;
 31 : Twiddle_W_r = 32925;
default : Twiddle_W_r = 0;
endcase
endfunction
function [`W-1:0] Twiddle_W_i;
input  [4:0]  k;
case(k)
 0 : Twiddle_W_i = 0;
 1 : Twiddle_W_i = 62324;
 2 : Twiddle_W_i = 59143;
 3 : Twiddle_W_i = 56023;
 4 : Twiddle_W_i = 52996;
 5 : Twiddle_W_i = 50089;
 6 : Twiddle_W_i = 47331;
 7 : Twiddle_W_i = 44748;
 8 : Twiddle_W_i = 42365;
 9 : Twiddle_W_i = 40205;
 10 : Twiddle_W_i = 38290;
 11 : Twiddle_W_i = 36637;
 12 : Twiddle_W_i = 35262;
 13 : Twiddle_W_i = 34178;
 14 : Twiddle_W_i = 33397;
 15 : Twiddle_W_i = 32925;
 16 : Twiddle_W_i = 32931;
 17 : Twiddle_W_i = 32925;
 18 : Twiddle_W_i = 33397;
 19 : Twiddle_W_i = 34178;
 20 : Twiddle_W_i = 35262;
 21 : Twiddle_W_i = 36637;
 22 : Twiddle_W_i = 38290;
 23 : Twiddle_W_i = 40205;
 24 : Twiddle_W_i = 42365;
 25 : Twiddle_W_i = 44748;
 26 : Twiddle_W_i = 47331;
 27 : Twiddle_W_i = 50089;
 28 : Twiddle_W_i = 52996;
 29 : Twiddle_W_i = 56023;
 30 : Twiddle_W_i = 59143;
 31 : Twiddle_W_i = 62324;
default : Twiddle_W_i = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_r;
input  [4:0]  k;
case(k)
 0 : Twiddle_W_ex_r = 1;
 1 : Twiddle_W_ex_r = 0;
 2 : Twiddle_W_ex_r = 0;
 3 : Twiddle_W_ex_r = 0;
 4 : Twiddle_W_ex_r = 0;
 5 : Twiddle_W_ex_r = 0;
 6 : Twiddle_W_ex_r = 0;
 7 : Twiddle_W_ex_r = 0;
 8 : Twiddle_W_ex_r = 0;
 9 : Twiddle_W_ex_r = 0;
 10 : Twiddle_W_ex_r = 0;
 11 : Twiddle_W_ex_r = 0;
 12 : Twiddle_W_ex_r = 0;
 13 : Twiddle_W_ex_r = 0;
 14 : Twiddle_W_ex_r = 0;
 15 : Twiddle_W_ex_r = 0;
 16 : Twiddle_W_ex_r = 0;
 17 : Twiddle_W_ex_r = 0;
 18 : Twiddle_W_ex_r = 0;
 19 : Twiddle_W_ex_r = 0;
 20 : Twiddle_W_ex_r = 0;
 21 : Twiddle_W_ex_r = 0;
 22 : Twiddle_W_ex_r = 0;
 23 : Twiddle_W_ex_r = 0;
 24 : Twiddle_W_ex_r = 0;
 25 : Twiddle_W_ex_r = 0;
 26 : Twiddle_W_ex_r = 0;
 27 : Twiddle_W_ex_r = 0;
 28 : Twiddle_W_ex_r = 0;
 29 : Twiddle_W_ex_r = 0;
 30 : Twiddle_W_ex_r = 0;
 31 : Twiddle_W_ex_r = 0;
default : Twiddle_W_ex_r = 0;
endcase
endfunction
function [1:0] Twiddle_W_ex_i;
input  [4:0]  k;
case(k)
 0 : Twiddle_W_ex_i = 0;
 1 : Twiddle_W_ex_i = 0;
 2 : Twiddle_W_ex_i = 0;
 3 : Twiddle_W_ex_i = 0;
 4 : Twiddle_W_ex_i = 0;
 5 : Twiddle_W_ex_i = 0;
 6 : Twiddle_W_ex_i = 0;
 7 : Twiddle_W_ex_i = 0;
 8 : Twiddle_W_ex_i = 0;
 9 : Twiddle_W_ex_i = 0;
 10 : Twiddle_W_ex_i = 0;
 11 : Twiddle_W_ex_i = 0;
 12 : Twiddle_W_ex_i = 0;
 13 : Twiddle_W_ex_i = 0;
 14 : Twiddle_W_ex_i = 0;
 15 : Twiddle_W_ex_i = 0;
 16 : Twiddle_W_ex_i = 2;
 17 : Twiddle_W_ex_i = 0;
 18 : Twiddle_W_ex_i = 0;
 19 : Twiddle_W_ex_i = 0;
 20 : Twiddle_W_ex_i = 0;
 21 : Twiddle_W_ex_i = 0;
 22 : Twiddle_W_ex_i = 0;
 23 : Twiddle_W_ex_i = 0;
 24 : Twiddle_W_ex_i = 0;
 25 : Twiddle_W_ex_i = 0;
 26 : Twiddle_W_ex_i = 0;
 27 : Twiddle_W_ex_i = 0;
 28 : Twiddle_W_ex_i = 0;
 29 : Twiddle_W_ex_i = 0;
 30 : Twiddle_W_ex_i = 0;
 31 : Twiddle_W_ex_i = 0;
default : Twiddle_W_ex_i = 0;
endcase
endfunction
endmodule

